<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, inject, ref, defineAsyncComponent } from 'vue';
import h5pVue from '@/components/general/h5p.vue';
import Modal from '@/components/general/Modal.vue';
import TextView from '@/components/general/TextView.vue';
//import Image from '@/components/general/Image.vue';

import MediaPlayer from '@/components/general/MediaPlayer.vue';
import { getFileType } from '@/lib/utils';

const Image = defineAsyncComponent(() => import('@/components/general/Image.vue'));


const props = defineProps<{
    body: any,
    url: string,
    info?: string,
    fontSize?: string,
    imgSize?: string,
    isExport?: boolean,
    hideUrl?: boolean,
    exportApi?: string,
    topbarClass?: string
}>();

const emits = defineEmits<{
    (e: 'loaded'): void
}>();

const configuration = inject<any>('configuration');;

const filePath = computed(() => {
    if (props.body && props.body.image) return completeURL(props.body.image);
    if (props.body && props.body.video) return completeURL(props.body.video);
    else {
        return completeURL(props.url.replace(/<p>/g, '').replace(/<\/p>/g, ''));
    }
});

const completeURL = (url: string) => {
    if (url) {
        if (url.includes('http://') || url.includes('https://'))
            return url;
        else {
            if (props.isExport) {
                return configuration.exportApiServer + url;
            } else {
                return configuration.apiServer + url;
            }
        }
    }
    return undefined;
}

const fileType = computed(() => {
    return getFileType(props.body, props.url);
});

const iconType = computed(() => {
    if (props.url) {
        if (props.url.includes(".pdf")) return "file-pdf-2";
        else if (props.url.includes(".docx") || props.url.includes(".doc") || props.url.includes(".odt"))
            return "file-word";
        else if (props.url.includes(".xlsx") || props.url.includes(".xls") || props.url.includes(".ods"))
            return "file-excel";
        else if (props.url.includes(".pptx") || props.url.includes(".ppt") || props.url.includes(".pps") || props.url.includes(".ppsx") || props.url.includes(".odp"))
            return "file-ppt";
        else if (props.url.includes(".txt")) return "file-text";
        //iWork suite generic file icon
        else if (props.url.includes(".pages") || props.url.includes(".numbers") || props.url.includes(".key"))
            return "file";
        else return 'file-upload';
    }
    else
        return 'file-upload';
});

const isH5PModalOpen = ref(false);
const showH5PModal = (value: boolean) => {
    isH5PModalOpen.value = value;
}

const h5pLogo = configuration.baseURL + configuration.basePath + "images/h5p_embedded.svg";

const editInfo = () => {

}

const contentLoaded = () => {
    emits('loaded');
}

</script>
<template>
    <div v-if="fileType" class="flex flex-col h-full" :class="[fontSize]">
        <div class="w-full max-w-full min-h-16">
            <div class="w-full relative h-full" :class="[topbarClass]" v-if="body && !body.modal && body.iframe">
                <div class="w-full h-5"></div><span @load="contentLoaded" v-html="body.iframe"></span>
                <div class="w-full h-8" v-if="!isExport"></div>
            </div>
            <div v-else>
                <img class="object-contain mt-4 mb-4 w-full" :src="h5pLogo" @click="showH5PModal(true)"
                    :style="[{ maxHeight: imgSize }]" @load="contentLoaded"
                    v-if="body && body.h5p && body.type === 'file'" />
                <div v-else-if="filePath && (fileType === 'image' || body && body.modal)">
                    <Image :src="filePath" :iframeURL="body.iframe" :imgSize="imgSize" @loaded="contentLoaded"
                        :topbarClass="topbarClass" />
                </div>
                <div class="relative h-full w-full" :class="[topbarClass]"
                    v-else-if="(fileType === 'audio' || fileType === 'video') && filePath">
                    <div class="w-full h-5"></div>
                    <MediaPlayer :type="fileType" :src="filePath" />
                    <div class="w-full h-8" v-if="!isExport"></div>
                </div>
                <div v-else-if="fileType">
                    <span class="break-all" v-if="body && body.file === null">{{ url }}</span>
                    <a :href="filePath" target="_blank" rel="opener"
                        class="w-full block text-gray-700 hover:text-gray-800 hover:no-underline">
                        <img class="object-contain w-full" :class="[topbarClass]" :key="url"
                            :src="filePath!.replace('pdf', 'png') + '?pdf=1'" :style="[{ maxHeight: imgSize }]"
                            v-if="url.includes('.pdf')" @load="contentLoaded" />
                        <span class="w-full inline-block text-center" v-else><i
                                :class="`ri-${iconType}-line text-[100px] leading-[150px]`"></i></span>
                    </a>
                </div>
            </div>
        </div>
        <div class="h-8 leading-8 z-10 px-1 flex flex-row gap-1"
            :class="[(fileType !== 'misc' || !fileType || filePath!.toLowerCase().endsWith('.pdf')) ? 'bg-white/80' : '', isExport ? 'mt-0' : '-mt-8']"
            v-if="body.logo || body.publisher || filePath!.toLowerCase().endsWith('.pdf') || (!body.h5p && url && !hideUrl)">
            <img class="size-6 mt-1" :src="body.logo" v-if="body.logo" />
            <strong class="capitalize leading-8 h-8 line-clamp-1 break-all text-ellipsis" v-if="body.publisher">{{
                body.publisher }}</strong>
            <div class="ml-auto">
                <a class="hover:no-underline hover:text-gray-800" :class="[{ 'text-gray-700': !isExport }]"
                    :href="completeURL(url)" target="_blank" rel="opener" v-if="body && !body.h5p && url && !hideUrl">{{
                        $t('placeholder.link') }}</a>
            </div>
        </div>
        <p class="text-gray-600 p-1" v-if="body?.description && (!body.iframe || body.modal)">{{ body.description }}</p>
        <div class="p-1" v-html="info" @dblclick="editInfo" v-if="info"></div>
    </div>
    <div v-else-if="body" class="flex flex-col h-full min-h-16">
        <div v-if="body?.image" class="min-h-24">
            <a :href="url">
                <img class="object-contain mx-auto" :class="[topbarClass]" :src="filePath"
                    :style="[{ maxHeight: imgSize }]" @load="contentLoaded" />
            </a>
        </div>
        <div class="p-1 mt-7" v-else>
            <TextView :fontSize="props.fontSize" :content="url" :contentLength="0"/>
        </div>
        <div class="-mt-8 h-8 max-h-8 leading-8 z-10 px-1 flex flex-row gap-1"
            :class="[((fileType !== 'misc' || !fileType)) ? 'bg-white/80' : '', isExport ? 'mt-0' : '-mt-8']"
            v-if="(body.logo || body.publisher || (!body.h5p && url && !hideUrl)) && body.image">
            <img class="size-6 mt-1" :src="body.logo" v-if="body.logo" />
            <strong class="capitalize leading-8 h-8 line-clamp-1 break-all text-ellipsis" v-if="body.publisher">{{
                body.publisher }}</strong>
            <div class="ml-auto"><a class="hover:no-underline hover:text-gray-800"
                    :class="[{ 'text-gray-700': !isExport }]" :href="completeURL(url)" target="_blank" rel="opener"
                    v-if="body && !body.h5p && url && !hideUrl">{{ $t('placeholder.link') }}</a></div>
        </div>
        <p class="text-gray-600 p-1 break-all" v-if="body?.description">{{ body.description }}</p>
        <div class="p-1" v-html="info" @dblclick="editInfo" v-if="info"></div>
    </div>
    <Modal v-if="isH5PModalOpen && filePath" @submit="showH5PModal(false)" :labelSubmit="$t('general.buttons.close')">
        <h5pVue :h5p="filePath" :key="filePath" />
    </Modal>
</template>